   // AddInMod.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "BuildMgr2.h"
#include "DSAddIn.h"
#include "Commands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Dieser Code wird beim ersten Laden des Add-Ins und beim Starten der Anwendung aufgerufen
//  jeder nachfolgenden Developer Studio-Sitzung

//***************************************************************************************************
//**																					  
//***************************************************************************************************
//**	@DOC		
//**	@END
//***************************************************************************************************
//inline
STDMETHODIMP CDSAddIn::OnConnection(IApplication* pApp, VARIANT_BOOL bFirstTime,
		long dwCookie, VARIANT_BOOL* OnConnection)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// 
	//	QUERY APPLICATION
	//
	IApplication* pApplication = NULL;

	if ( FAILED( pApp->QueryInterface(IID_IApplication, (void**) &pApplication) )
		|| pApplication == NULL)
	{
		*OnConnection = VARIANT_FALSE;
		return S_OK;
	}

	//
	//	STORE COOKIE
	//
	m_dwCookie = dwCookie;

	//
	//	CREATE COMMAND OBJECT
	//
	CCommandsObj::CreateInstance(&m_pCommands);
	m_pCommands->AddRef();

	//
	//	CONNECT COMMANDS WITH APPLICATION
	//
	m_pCommands->SetApplicationObject(pApplication);

	//
	//	SET ADDIN INFO
	//
	VERIFY_OK(pApplication->SetAddInInfo((long) AfxGetInstanceHandle(),
		(LPDISPATCH) m_pCommands, IDR_TOOLBAR_MEDIUM, IDR_TOOLBAR_LARGE, m_dwCookie));

	//
	//	REGISTER COMMANDS WITH IDE
	//
	*OnConnection = this->AddCommands( pApplication, bFirstTime );

	//
	//	RETURN SUCCESS
	//
	return S_OK;
}

// Dieser Code wird bei Shut-Down-Vorgngen und beim Entfernen des Add-Ins aus dem Speicher aufgerufen

//***************************************************************************************************
//**																					  
//***************************************************************************************************
//**	@DOC		
//**	@END
//***************************************************************************************************
//inline
STDMETHODIMP CDSAddIn::OnDisconnection(VARIANT_BOOL bLastTime)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	m_pCommands->UnadviseFromEvents();
	m_pCommands->Release();
	m_pCommands = NULL;

	return S_OK;
}

//***************************************************************************************************
//**																					  
//***************************************************************************************************
//**	@DOC		
//**	@END
//***************************************************************************************************
//inline
VARIANT_BOOL CDSAddIn::AddCommands( IApplication* pApplication, VARIANT_BOOL bFirstTime )
{
	//
	//	REGISTER "CONFIGURE" COMMAND
	//
	LPCTSTR			szCommand = _T("BuildMgr.Configure");
	CString			strCmdString;
					strCmdString.LoadString( IDS_CMD_STRING_CONFIGURE );
					strCmdString = szCommand + strCmdString;

	CComBSTR		bszCmdString(strCmdString);
	CComBSTR		bszMethod(_T("BuildMgrConfigure"));
	CComBSTR		bszCmdName(szCommand);
	VARIANT_BOOL	bRet;

	VERIFY_OK(pApplication->AddCommand(bszCmdString, bszMethod, 1, m_dwCookie, &bRet));

	if (bRet == VARIANT_FALSE)
	{
		return VARIANT_FALSE;
	}

	//
	//	ADD "CONFIGURE" BUTTON TO TOOLBAR
	//
	if (bFirstTime == VARIANT_TRUE)
	{
		VERIFY_OK(pApplication->AddCommandBarButton(dsGlyph, bszCmdName, m_dwCookie));
	}

	//
	//	REGISTER "RUN" COMMAND
	//
					szCommand = _T("BuildMgr.Run");
					strCmdString.LoadString( IDS_CMD_STRING_RUN );
					strCmdString = szCommand + strCmdString;

					bszCmdString = strCmdString;
					bszMethod = _T("BuildMgrRun");
					bszCmdName = szCommand;

	VERIFY_OK(pApplication->AddCommand(bszCmdString, bszMethod, 0, m_dwCookie, &bRet));

	if (bRet == VARIANT_FALSE)
	{
		return VARIANT_FALSE;
	}

	//
	//	ADD "RUN" BUTTON TO TOOLBAR
	//
	if (bFirstTime == VARIANT_TRUE)
	{
		VERIFY_OK(pApplication->AddCommandBarButton(dsGlyph, bszCmdName, m_dwCookie));
	}

	//
	//	RETURN SUCCESS
	//
	return VARIANT_TRUE;
}
